/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Qualidade de Fornecimento                                                  */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8620_QFOSTP_TESTEPROD_UPCHILD                                        */
/*                                                                            */
/* Descrio:                                                                 */
/*  Updata o tipo de prato, marca de referncia e custo x benefcio de um     */
/*  teste de produto para todos os filhos deste teste.                        */
/*                                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 28/02/2001 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
/******************************************************************************/
/* PARAMETROS:                                                                */
/* P_NRTESTEPROD  -  Nmero de teste pai.                                     */
/******************************************************************************/
/* @C:\SISTEMAS\DBA\SQL\ORACLE\8620_QFOSTP_TESTEPROD_UPCHILD.SQL              */
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8620_QFOSTP_TESTEPROD_UPCHILD.SQL              */
/******************************************************************************/
CREATE OR REPLACE PROCEDURE TESTEPROD_UPCHILD
   (P_NRTESTEPROD IN TESTEPROD.NRTESTEPROD%TYPE) IS

   V_COUNT        NUMBER;

BEGIN
   COMMIT;
   FOR C_TESTEFILHO IN /* RETORNA TODOS OS TESTES FILHOS */
   (SELECT
       NRTESTEPROD
    FROM
       TESTEPROD
    WHERE
       NRTESPRDORIG = P_NRTESTEPROD)
   LOOP
/*######################## TIPO DE PRATO #####################################*/

      DELETE FROM TPPRATTEST
      WHERE NRTESTEPROD = C_TESTEFILHO.NRTESTEPROD;

      INSERT INTO TPPRATTEST (NRTESTEPROD, CDTIPOPRAT)
      (SELECT
          C_TESTEFILHO.NRTESTEPROD,
          CDTIPOPRAT
       FROM
          TPPRATTEST
       WHERE
          NRTESTEPROD = P_NRTESTEPROD);

/*######################## MARCA DE REFERNCIA ###############################*/

      DELETE FROM MARCTESTPR
      WHERE NRTESTEPROD = C_TESTEFILHO.NRTESTEPROD;

      INSERT INTO MARCTESTPR (NRTESTEPROD, CDMARCA)
      (SELECT
          C_TESTEFILHO.NRTESTEPROD,
          CDMARCA
       FROM
          MARCTESTPR
       WHERE
          NRTESTEPROD = P_NRTESTEPROD);

/*######################## CUSTO X BENEFICIO #################################*/

      DELETE FROM CUSBENTEST
      WHERE NRTESTEPROD = C_TESTEFILHO.NRTESTEPROD;

      FOR C_CUSTOBEN IN
      (SELECT
          DSCUSBENTEST
       FROM
          CUSBENTEST
       WHERE
          NRTESTEPROD = P_NRTESTEPROD)
      LOOP
         INSERT INTO CUSBENTEST (NRTESTEPROD, DSCUSBENTEST)
         VALUES (C_TESTEFILHO.NRTESTEPROD, C_CUSTOBEN.DSCUSBENTEST);
      END LOOP;
      COMMIT;
   END LOOP;
END;
/
